## camitk 3.4.0

=== CMakeLists.txt ===
#--------------------------------------------
#
#         CamiTK Open Source CEP Set
#
#--------------------------------------------
cmake_minimum_required(VERSION 2.6)

project(camitkopensource)

# Allow testing of the whole camitk-opensource project
include(CTest)
enable_testing()

# Specific to SDK: control the version (major, minor, default patch and )
set(CAMITK_PROJECT_NAME "CamiTK")
set(CAMITK_VERSION_MAJOR "3")
set(CAMITK_VERSION_MINOR "4")
set(CAMITK_VER_NICKNAME "iris") # blue, sapphire, azure, *indigo*, iris, Teal, cyan, turquoise, denim, celeste, zaffre, glaucous, ultramarine, cerulean
set(CAMITK_VERSION_PATCH "0") # patch version for packaging, change when appropriate
string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)

# Specific to SDK: this is the SDK build
set(CAMITK_SDK_BUILD TRUE)

#-- This is a CEP set...
set(CAMITK_EXTENSION_PROJECT_SET TRUE CACHE BOOL "Is this a CamiTK Extension Project Set?")
set(CAMITK_EXTENSION_PROJECT_SET_NAME "camitk-opensource" CACHE STRING "CEP Set Name")

# Configure CamiTK Opensource packaging.
# Must be done before parsing extensions CMakeLists.txt files.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros)
set(CAMITK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
include(CamiTKOpenSourcePackaging)
camitk_opensource_packaging()

# Specific to SDK: first compile the SDK (it looks like a CEP but is sooooo special...)
add_subdirectory(sdk)

# ...composed by the following CamiTK Extension Projects
add_subdirectory(imaging)
add_subdirectory(modeling)

# Do we wrapp CamiTK for scripting it into Python using Shiboken and PySide ?
set(CAMITK_BINDING_PYTHON CACHE BOOL FALSE)

# Consider python binding only if the CMake variable is checked
if(CAMITK_BINDING_PYTHON)
    add_subdirectory(python_sdk)
endif()



camitk_sub_project_validate(CEP_SET)

=== sdk/CMakeLists.txt ===
#--------------------------------------------
#         CamiTK Extension Project
#
# You should probably NOT modify this file...
# Please edit CEPDescription.cmake instead
#--------------------------------------------

cmake_minimum_required(VERSION 2.6)

include(SDKConfig.cmake) 

# Please add your project name inside the project() brackets, e.g. project(myProject)
project(${CEP_NAME})

# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

# include global install of SDK
# This is a SDK build => global install is done in CMAKE_INSTALL_PREFIX
add_custom_target(sdk_global_install
    COMMAND ${CMAKE_COMMAND} -E echo "Global Installation in ${CMAKE_INSTALL_PREFIX}"
    # First remove the WIN32 system runtime libraries dependencies
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."
    # Second cmake to install
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target sdk_copy_camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} -E echo "Global installation in ${CMAKE_INSTALL_PREFIX} done."
    COMMENT "Global installation"
)

# The definition of SDK_TOP_LEVEL_SOURCE_DIR and SDK_TOP_LEVEL_BINARY_DIR are
# are needed to store the current source dir to pass as an argument to the ConfigureCamiTKDirTxt.cmake script in sdk_copy_camitkdirtxt
set(SDK_TOP_LEVEL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SDK_TOP_LEVEL_BINARY_DIR ${CMAKE_BINARY_DIR})
# specific top-level target that prepare and copy the CamiTKDir.txt file in ${CAMITK_USER_DIR}
add_custom_target(sdk_copy_camitkdirtxt
    # prepare the CamiTKConfig.cmake for installation
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
                             -DCAMITK_USER_DIR=${CAMITK_USER_DIR}
                             -DSDK_TOP_LEVEL_SOURCE_DIR=${SDK_TOP_LEVEL_SOURCE_DIR}
                             -DSDK_TOP_LEVEL_BINARY_DIR=${SDK_TOP_LEVEL_BINARY_DIR}
                             -P ${CMAKE_CURRENT_SOURCE_DIR}/ConfigureCamiTKDirTxt.cmake
    # Make sure the user dir exists
    COMMAND ${CMAKE_COMMAND} -E make_directory "${CAMITK_USER_DIR}"
    # Remove the previous version
    COMMAND ${CMAKE_COMMAND} -E remove -f ${CAMITK_USER_DIR}/CamiTKDir.txt
    # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "CamiTKDir.txt [${CMAKE_INSTALL_PREFIX}] copied in ${CAMITK_USER_DIR}"
)

# camitk_local_install == install in User Config directory
add_custom_target(sdk_local_install
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR}"
    # First cmake to redefine install prefix
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CAMITK_USER_DIR} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."    
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target sdk_copy_camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR} done."
    COMMENT "Local installation"
)

# make sure a copy of the CamiTKDir.txt file is written to ${CAMITK_USER_DIR}
# even if the user is just invoking the "install" target (from the IDE or command line)
install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target sdk_copy_camitkdirtxt)")

# include CamiTK auto-documentation generation
include(CamiTKApiDoc)

# initialize subproject management
camitk_sub_project_init()

# Create a shiboken path variable containing the CamiTK SDK tree structure, needed by shiboken to find C++ classes to wrap
set(SHIBOKEN_CAMITK_SDK_PATH ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")

# initialize automatic tests parsing
camitk_parse_test_init()

# add all subprojects, in dependencies order
camitk_add_subdirectory(libraries)
camitk_add_subdirectory(testapplications)
camitk_add_subdirectory(components)
camitk_add_subdirectory(actions)
camitk_add_subdirectory(viewers)
camitk_add_subdirectory(applications)
camitk_add_subdirectory(cmake) # for cmake module installation

# Validate project.xml file for CDash
camitk_sub_project_validate()

# Validate CamiTKTestsLevel.txt file for wiki
camitk_parse_test_validate()

message(STATUS "compiling in ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_CFG_INTDIR=${CMAKE_CFG_INTDIR}")
message(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}")

=== modeling/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro apropriately

# Add subdirectories in CMake project, manually => handling dependencies
camitk_add_subdirectory(physicalmodel)
camitk_add_subdirectory(mmlcomponent)

=== modeling/libraries/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a library, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_library() macro apropriately


# --- add every given library in dependencies order
camitk_add_subdirectory(lml)
camitk_add_subdirectory(pml)
camitk_add_subdirectory(mml)

=== imaging/actions/itkfilters/CMakeLists.txt ===
if (WIN32)
    if(CMAKE_CL_64)
        # for 64 bits platform, enable big obj (.o) handling, in ordere to correctly compile this (heavy) project
        if (MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}/bigobj")
            elseif(MINGW)
                set(CMAKE_CXX_FLAGS "-O3 -finline-functions")
            endif()
    endif()
endif()

camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    CXX_FLAGS "-w"
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This action features basic ITK image processing filters"
                    TEST_APPLICATION ${APPLICATION_TEST_ACTION}
                    TEST_FILES bassin.msh BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img brain.mha diaphragm.pml head1.STL
)

=== imaging/actions/itksegmentation/CMakeLists.txt ===
camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    NEEDS_ACTION_EXTENSION multipicking
                    CEP_NAME CEP_IMAGING
                    CXX_FLAGS "-w"
                    DESCRIPTION "This action features basic ITK image processing segmentation algorithms"
                    TEST_APPLICATION ${APPLICATION_TEST_ACTION}
                    TEST_FILES bassin.msh diaphragm.pml head1.STL
)

=== imaging/components/dicom/CMakeLists.txt ===
camitk_extension(   COMPONENT_EXTENSION
                    NEEDS_GDCM
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This allows one to read a single DICOM image file (.dcm) using the library GDCM 2.2.x"
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
)

=== modeling/actions/mml/CMakeLists.txt ===
camitk_extension(ACTION_EXTENSION
                 NEEDS_LIBXML2
                 NEEDS_XSD
                 NEEDS_CEP_LIBRARIES pml mml monitoring lml 
                 NEEDS_COMPONENT_EXTENSION physicalmodel mml vtkmesh physicalmodel msh
                 CEP_NAME CEP_MODELING
                 DESCRIPTION "Action MML features algorithms applicable on MML components."
                 TEST_APPLICATION ${APPLICATION_TEST_ACTION}
                 TEST_FILES BigEndian.hdr
)

=== modeling/components/mmlcomponent/CMakeLists.txt ===
if(COMPONENT_MML)
    set(MML_GENERATE_GUI ON CACHE BOOL "Forced by COMPONENT_MML" FORCE)

    #FIXME Sofa support => fix sofa dependency properly
    if(MML_SOFA_SUPPORT)
        if(WIN32)
            set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/win32/ReleaseVC9 ${MML_SOFA_DIR}/lib/win32 ${MML_SOFA_DIR}/lib ${MML_SOFA_DIR}/bin)
        else()
            set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/linux ${MML_SOFA_DIR}/lib)
        endif()
        link_directories(${MML_SOFA_LIB_DIR})
    endif()
endif()

camitk_extension(   COMPONENT_EXTENSION
                    DEFINES COMPILE_MMLCOMPONENT_API
                    NEEDS_LIBXML2
                    NEEDS_XSD
                    NEEDS_CEP_LIBRARIES pml lml mml monitoringgui monitoring
                    NEEDS_COMPONENT_EXTENSION  vtkmesh physicalmodel
                    HEADERS_TO_INSTALL  MMLComponentExtension.h
                                        MMLComponent.h
                                        MMLDisplay.h
                                        MMLMonitorDisplay.h
                                        MMLMonitorDisplayFactory.h
                                        MMLMonitorDisplays/Colors.h
                                        MMLMonitorDisplays/Arrows.h
                                        MMLMonitorDisplays/Tabular.h
                                        MMLComponentPopup.h
                                        MMLComponentAPI.h
                    CEP_NAME CEP_MODELING
                    DESCRIPTION "Component MML allows one to handle XML file that compare biomechanical simulations with different simulators"
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
)

=== modeling/components/physicalmodel/CMakeLists.txt ===
# build component extension
camitk_extension(   COMPONENT_EXTENSION
                    NEEDS_LIBXML2
                    NEEDS_CEP_LIBRARIES pml lml
                    INCLUDE_DIRECTORIES loads ${CMAKE_CURRENT_BINARY_DIR}/loads ${CAMITK_INCLUDE_DIR}/libraries
                    DEFINES COMPILE_PHYSICALMODEL_COMPONENT_API
                    HEADERS_TO_INSTALL  PMComponentAPI.h
                                        AtomDC.h
                                        PMManagerDC.h
                                        ComponentDC.h
                                        MultiComponentDC.h
                                        StructuralComponentDC.h
                                        loads/AnimationMotorAddon.h
                                        loads/LoadsManager.h
                                        loads/LoadsSimulation.h
                                        loads/Decoration.h
                                        loads/AtomDecoration.h
                                        loads/AnyDecoration.h
                    CEP_NAME CEP_MODELING
                    DESCRIPTION "Provide the basic components to handle biomechanical models"
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
                    DISABLE_TESTLEVEL1
)


if(COMPONENT_PHYSICALMODEL)
  # for animation motor export
  #add_definitions(-DCOMPILE_PHYSICALMODEL_COMPONENT_API)

#-------------------
# api documentation
#-------------------
# TODO include this settings in the doxygen API doc generation of camitk set(COMPONENT_PHYSICALMODEL_GENERATE_API_DOC FALSE CACHE BOOL "generate api documentation using doxygen for physical model component")
 if(COMPONENT_PHYSICALMODEL_GENERATE_API_DOC)
  include(FindDoxygen)
  if (DOXYGEN)

    option(COMPONENT_PHYSICALMODEL_DOC_WITH_STATIC "Create documentation for static members" ON)
    option(COMPONENT_PHYSICALMODEL_DOC_WITH_PRIVATE "Create documentation for private members" ON)
    option(COMPONENT_PHYSICALMODEL_DOC_WITH_LOCAL "Create documentation for local members" ON)
    option(COMPONENT_PHYSICALMODEL_DOC_WITH_INTERNAL "Create documentation for internal features" ON)

    mark_as_advanced(
      COMPONENT_PHYSICALMODEL_DOC_WITH_PRIVATE
      COMPONENT_PHYSICALMODEL_DOC_WITH_STATIC
      COMPONENT_PHYSICALMODEL_DOC_WITH_LOCAL
      COMPONENT_PHYSICALMODEL_DOC_WITH_INTERNAL
    )

    if (COMPONENT_PHYSICALMODEL_DOC_WITH_PRIVATE)
      set(DOXYGEN_EXTRACT_PRIVATE YES)
    else ()
      set(DOXYGEN_EXTRACT_PRIVATE NO)
    endif ()

    if (COMPONENT_PHYSICALMODEL_DOC_WITH_STATIC)
      set(DOXYGEN_EXTRACT_STATIC YES)
    else ()
      set(DOXYGEN_EXTRACT_STATIC NO)
    endif ()

    if (COMPONENT_PHYSICALMODEL_DOC_WITH_LOCAL)
      set(DOXYGEN_EXTRACT_LOCAL YES)
    else ()
      set(DOXYGEN_EXTRACT_LOCAL NO)
    endif ()

    if (COMPONENT_PHYSICALMODEL_DOC_WITH_INTERNAL)
      set(DOXYGEN_EXTRACT_INTERNAL YES)
    else ()
      set(DOXYGEN_EXTRACT_INTERNAL NO)
    endif ()

    if (DOT)
      set(HAVE_DOT YES)
    else ()
      set(HAVE_DOT NO)
    endif ()

    set(DOXYGEN_LANGUAGE "English" CACHE STRING "Language used by doxygen")
    mark_as_advanced(DOXYGEN_LANGUAGE)

    set(DOXYGEN_SOURCE_DIR ${CURRENT_SOURCE_DIR}
      ${CURRENT_SOURCE_DIR}/loads
    )

    set(DOXYGEN_OUTPUT_DIR ${CURRENT_SOURCE_DIR}/api-doc)
    message("----> Documenation output dir is ${DOXYGEN_OUTPUT_DIR}")
    string(REGEX REPLACE ";" " " DOXYGEN_INPUT_LIST "${DOXYGEN_SOURCE_DIR}")

    configure_file(doxygen.conf.in ${CMAKE_CURRENT_BINARY_DIR}/doxygen.conf)
    #set(HTML_TARGET ${DOXYGEN_OUTPUT_DIR}/html/index.html)
    add_custom_target(api-doc ALL
          ${DOXYGEN} ${CMAKE_CURRENT_BINARY_DIR}/doxygen.conf
          DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen.conf)

    set_target_properties(api-doc PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)

  else (DOXYGEN)
      message(STATUS "WARNING: Doxygen not found - API documentation and reference manual will not be created")
  endif ()
 endif()
endif()

=== modeling/libraries/lml/CMakeLists.txt ===
project(LML)

cmake_minimum_required(VERSION 2.6)

# Is this tool is compiled inside or outside CamiTK (as a standalone)?
if (NOT CEP_NAME STREQUAL "modeling")
  # if this tool is compiled independently from CamiTK
  set(LML_STANDALONE ON CACHE BOOL "ON only if LML compiled outside CAMITK SDK")
  message(FATAL_ERROR "Compilation of LML outside CamiTK SDK not implemented yet. Please contact authors")
endif()

# Version (in CamiTK)
set(VERSION_STRING "lml - ${CAMITK_VERSION_STRING} (c) UJF-Grenoble 1, CNRS, TIMC-IMAG UMR 5525")
configure_file(${LML_SOURCE_DIR}/LoadsVersion.h.in ${LML_BINARY_DIR}/LoadsVersion.h)

set( HEADERS 
      Direction.h 
      Force.h 
      ForceUnit.h 
      Load.h 
      Loads.h 
      ${LML_BINARY_DIR}/LoadsVersion.h
      Pressure.h 
      PressureUnit.h 
      Rotation.h 
      RotationUnit.h 
      TargetList.h 
      Translation.h 
      TranslationUnit.h
      Acceleration.h
      AccelerationUnit.h
      Unit.h 
      ValueEvent.h 
      XMLLoads.h 
    )

set( SRCS
      Force.cpp 
      ForceUnit.cpp 
      Load.cpp 
      Loads.cpp 
      PressureUnit.cpp 
      RotationUnit.cpp 
      TargetList.cpp 
      Translation.cpp 
      TranslationUnit.cpp
      AccelerationUnit.cpp
      ValueEvent.cpp 
      XMLLoads.cpp 
      ${HEADERS}
    )

camitk_library(STATIC
               SOURCES ${SRCS}
               NEEDS_LIBXML2
               HEADERS_TO_INSTALL ${HEADERS}
               CEP_NAME CEP_MODELING
               DESCRIPTION "Tools to describe a biomechanical model."
)

#---------
# testing
#---------
add_subdirectory(test)

#-------------------
# api documentation
#-------------------

option(APIDOC_GENERATE_FOR_LML "Build API documentation for LML" OFF)

if(APIDOC_GENERATE_FOR_LML)
  find_package(Doxygen REQUIRED)
  if(DOXYGEN)
      add_subdirectory(api-doc)
  else()
      MESSAGE(STATUS "WARNING: Doxygen not found - LML API documentation and reference manual will not be created")
  endif()
endif()

=== modeling/libraries/mml/CMakeLists.txt ===
# Is this tool is compiled inside or outside CAMITK (as a standalone)?
if (NOT CEP_NAME STREQUAL "modeling")
  # if this tool is compiled independently from CamiTK
  set(MML_STANDALONE ON CACHE BOOL "ON only if MML compiled outside CAMITK SDK")
  message(SEND_ERROR "Compilation of MML outside CamiTK SDK not implemented yet. Please contact authors")
endif()

set(MML_INCLUDE_DIRECTORIES
  ${CAMITK_INCLUDE_DIRECTORIES}
  ${CAMITK_INCLUDE_DIR}/libraries
  ${CAMITK_INCLUDE_DIR}/libraries/monitoring
  ${CAMITK_INCLUDE_DIR}/libraries/mml
  ${CAMITK_INCLUDE_DIR}/libraries/pml
  ${CAMITK_INCLUDE_DIR}/libraries/lml
  ${LIBXML2_INCLUDE_DIR}
  ${XERCESC_INCLUDE_DIR}
  ${XSD_INCLUDE_DIR}
)

set(MML_LIBRARIES
  ${LIBXML2_LIBRARIES}
  ${XERCESC_LIBRARIES}
)

# default list of subdirectory
add_subdirectory(schema)
add_subdirectory(monitoring)
add_subdirectory(applications)

=== debian/changelog ===
camitk (3.4.0-1build1) vivid; urgency=medium

  * No-change rebuild for new gdcm

 -- Iain Lane <iain@orangesquash.org.uk>  Fri, 07 Nov 2014 17:59:50 +0000

camitk (3.4.0-1) unstable; urgency=medium

  * New upstream release. 

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Tue, 28 Oct 2014 15:12:30 +0100

camitk (3.3.2-2) unstable; urgency=low

  * Fix autopkgtest for 3.3.2  
    Closes: #758130

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Tue, 23 Sep 2014 11:25:42 +0200

=== debian/control ===
Source: camitk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Emmanuel Promayon <Emmanuel.Promayon@imag.fr>,
           Nicolas Saubat <nicolas.saubat@imag.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libvtk5-dev (>= 5.8),
               libqt4-dev,
               libvtk5-qt4-dev (>= 5.8),
               xsdcxx,
               libinsighttoolkit3-dev (>= 3.20),
               libxerces-c-dev,
               libxml2-dev,
               libgdcm2-dev,
               libfftw3-dev,
               libqtwebkit-dev | libqt4-dev (<< 4.7),
               libvtkgdcm2-dev,
               libqt4-opengl-dev,
               xvfb,
               xauth
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/camitk/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/camitk/trunk/
Homepage: http://camitk.imag.fr/
X-Homepage: https://forge.imag.fr/projects/camitk/
Testsuite: autopkgtest

Package: libcamitk3
Architecture: any
Depends: libqtpropertybrowser3 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: libcamitk3-dev
Architecture: any
Section: libdevel
Depends: libcamitk3 (= ${binary:Version}),
         libqtpropertybrowser3-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: camitk-imp
Suggests: camitk-actionstatemachine
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard application to create new 
 extensions.

Package: libcamitk3-data
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the examples and test data for CamiTK.

Package: libcamitk3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: camitk-actionstatemachine
Description: workbench application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-imp is the CamiTK workbench application where you can test
 all available extensions for prototyping.
 It provides an easy and interactive access to all available data and
 algorithm parameters, including the one you build yourself using
 the CamiTK SDK.
 .
 For example, camitk-imp can visualize medical images from a lot of different
 (standard) formats, offers image processing and segmentation algorithms to
 reconstruct a mesh geometry and run a biomechanical simulation.

Package: camitk-actionstatemachine
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-imp
Description: pipeline replay application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-actionstatemachine is able to replay a pipeline (workflow) of CamiTK 
 actions.
 This application takes an CamiTK augmented version of a SCXML subset as input
 and allow to replay interactive the described state-machine containing a list
 of CamiTK actions and transitions.

Package: libqtpropertybrowser3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Qt Property Browser Library - runtime
 A framework providing a set of graphical editors for 
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains the shared libraries needed to run applications
 linked against libqtpropertybrowser3.

Package: libqtpropertybrowser3-dev
Architecture: any
Section: libdevel
Depends: libqtpropertybrowser3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Qt Property Browser Library - development
 A framework providing a set of graphical editors for 
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains development files needed to build applications
 using Qt Property Browser

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# CamiTK version from d/changelog)
CHANGELOG_VERSION := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
FULL_VERSION := $(shell echo '$(CHANGELOG_VERSION)' | sed -e 's/^[[:digit:]]*://' -e 's/[~-].*//')
VER_MAJOR := $(shell echo '$(FULL_VERSION)' | cut -f1 -d".")
VER_MINOR := $(shell echo '$(FULL_VERSION)' | cut -f2 -d".")
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

# package aliases (see d/control)
pkg_lib = libcamitk$(VER_MAJOR)
pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
pkg_dev = libcamitk$(VER_MAJOR)-dev
pkg_qpb_dev = libqtpropertybrowser$(VER_MAJOR)-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp
pkg_asm = camitk-actionstatemachine

# dpkg-shlibdeps needs to know about camitk extension directories to manage inner-dependencies
# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
PKG_LIB_DIR := $(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}
# for component extensions:
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/components/
# for action extensions: 
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/actions/
# for private libraries:
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/
# during test, the build dir path is also needed
LIB_BUILD_DIR := $(CURDIR)/camitk-build/lib
PRIVATE_LIB_BUILD_DIR := $(LIB_BUILD_DIR)/camitk-${VER_SHORT}
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_BUILD_DIR):$(PRIVATE_LIB_BUILD_DIR)/components/:$(PRIVATE_LIB_BUILD_DIR)/actions/:$(PRIVATE_LIB_BUILD_DIR)/
# export for all d/rules subshell (test and dpkg-shlibdeps included)
export LD_LIBRARY_PATH

# CMake flags are of two types:
# - generic (to tell cmake to build proper binaries)
# - CamiTK specific options
# Notes:
# - if you would like a more verbose camitk at run-time, you can add -DCAMITK_LOG_LEVEL=2
# - translation is not ready yet, so disable for now
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH:BOOL=TRUE \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=FALSE \
	-DCMAKE_BUILD_TYPE:STRING=None \
	\
	-DCEP_IMAGING:BOOL=TRUE \
	-DCEP_MODELING:BOOL=TRUE \
	\
	-DAPIDOC_SDK:BOOL=TRUE \
	-DCAMITK_DISABLE_TRANSLATION=TRUE

%:
	# For debian build, do not authorize parallel build (too much RAM needed for Imaging CEP)
	dh $@ --builddirectory=camitk-build
	# For local personal build, parallel is ok as there is enough RAM for heavy-templated Imaging CEP
	#dh $@ --parallel --builddirectory=camitk-build  

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# let's be smart with doc
override_dh_auto_build-indep:
	$(MAKE) -C camitk-build apidoc
	# remove the javascript search field
	rm -f camitk-build/share/camitk-$(VER_SHORT)/apidoc/html/jquery.js

# No tests needed for docs
override_dh_auto_test-indep:

# a selection of relevant tests
override_dh_auto_test:
	# Use the CamiTK test suite
	# Note: all tests require an X server, xvfb-run is needed to have a virtual one
	# Another way: xvfb-run --auto-servernum $(MAKE) -C camitk-build ARGS="-V" test
	(cd camitk-build && xvfb-run --auto-servernum ctest -V --timeout 300)

# make packages
override_dh_install:
	# $(CURDIR) is the current source dir
	# camitk dynamic library
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/libcamitkcore.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so.*
	# camitk-config is part of libcamitk
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/bin/camitk-config
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/share/pixmaps/camitk-config.xpm
	dh_installman -p$(pkg_lib) debian/tmp/usr/share/man/man1/camitk-config.1  

	# separate packaging for qtpropertybrowser (can be used independently from camitk)
	dh_install -p$(pkg_qpb) debian/tmp/usr/lib/libqtpropertybrowser.so.* usr/lib

	# camitk developer package
	# camitk so and headers and static libs 
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libcamitkcore.so usr/lib 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/camitkcore
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/cepcoreschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/actions
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/components
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/pml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/lml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/mml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoring
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoringgui
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/*.cmake 
	# wizard
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-wizard
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/applications/camitk-wizard.desktop
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/pixmaps/camitk-wizard.xpm
	# cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-cepgenerator
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-cepgenerator.1
	# test programs
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testactions
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-testactions.1
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testcomponents
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-testcomponents.1

	# qtpropertybrowser so and headers (includes are put directly in usr/include as package should be generic/independant from CamiTK)
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/lib/libqtpropertybrowser.so usr/lib
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/qtpropertybrowser usr/include

	# api doc
	dh_install -p$(pkg_doc) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/apidoc

	# all test data
	dh_install -p$(pkg_data) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/testdata

	# imp
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/bin/camitk-imp
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/share/applications/camitk-imp.desktop
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/share/pixmaps/camitk-imp.xpm
	dh_installman -p$(pkg_imp) debian/tmp/usr/share/man/man1/camitk-imp.1

	# asm
	dh_install -p$(pkg_asm) --autodest debian/tmp/usr/bin/camitk-actionstatemachine
	dh_install -p$(pkg_asm) --autodest debian/tmp/usr/share/pixmaps/camitk-actionstatemachine.xpm
	dh_installman -p$(pkg_asm) debian/tmp/usr/share/man/man1/camitk-actionstatemachine.1

override_dh_builddeb:
	dh_builddeb -- -Z xz

# see http://lists.debian.org/debian-mentors/2012/07/msg00124.html
get-orig-source:
	mkdir -p ../tarballs
	PERL_LWP_SSL_VERIFY_HOSTNAME=0 uscan --rename --verbose --force-download --destdir=../tarballs

=== debian/tests/control ===
Tests: config
Depends: libcamitk3 (>=3.2.2), xvfb, xauth

=== debian/watch ===
version=3
http://camitk.imag.fr/devDownload.php .*/camitk-(\d.*?)(?:-.*)?\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
